package cn.com.tenlion.configcolumn.service.configcolumngroup;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.configcolumn.pojo.dtos.configcolumngroup.ConfigColumnGroupDTO;
import cn.com.tenlion.configcolumn.pojo.vos.configcolumngroup.ConfigColumnGroupVO;
import cn.com.tenlion.configcolumn.pojo.bos.configcolumngroup.ConfigColumnGroupBO;
import cn.com.tenlion.configcolumn.pojo.pos.configcolumngroup.ConfigColumnGroupPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IConfigColumnGroupService
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-06-26 13:59:22
 * @Version: 3.0
 **/
public interface IConfigColumnGroupService {

    /**
     * 新增
     *
     * @param configColumnGroupVO
     * @return
     */
    void save(ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 新增
     *
     * @param token
     * @param configColumnGroupVO
     * @return
     */
    void save(String token, ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 新增
     *
     * @param configColumnGroupVO
     * @return configColumnGroupId
     */
    String saveReturnId(ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 新增
     *
     * @param token
     * @param configColumnGroupVO
     * @return configColumnGroupId
     */
    String saveReturnId(String token, ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 删除
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改
     *
     * @param configColumnGroupId
     * @param configColumnGroupVO
     * @return
     */
    void update(String configColumnGroupId, ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 修改
     *
     * @param token
     * @param configColumnGroupId
     * @param configColumnGroupVO
     * @return
     */
    void update(String token, String configColumnGroupId, ConfigColumnGroupVO configColumnGroupVO);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnGroupDTO get(Map<String, Object> params);


    /**
     * 详情
     *
     * @param configColumnGroupCode 栏目组编码
     * @return
     */
    ConfigColumnGroupDTO getByCode(String configColumnGroupCode);

    /**
     * 详情
     *
     * @param configColumnGroupId
     * @return
     */
    ConfigColumnGroupDTO get(String configColumnGroupId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnGroupBO getBO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configColumnGroupId
     * @return
     */
    ConfigColumnGroupBO getBO(String configColumnGroupId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigColumnGroupPO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configColumnGroupId
     * @return
     */
    ConfigColumnGroupPO getPO(String configColumnGroupId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnGroupDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnGroupBO> listBO(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigColumnGroupPO> listPO(Map<String, Object> params);

    /**
     * 分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ConfigColumnGroupDTO>> listPage(ListPage page);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    /**
     * 供移动端使用
     * @param params
     * @return
     */
    List<ConfigColumnGroupDTO> listToApp(String token, Map<String, Object> params);

}